// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeList defines model for ComposeList.
type ComposeList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []ComposeStatus `json:"items"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchPackagesRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The list of composes
	// (GET /composes/)
	GetComposeList(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Download the artifact for a compose.
	// (GET /composes/{id}/download)
	GetComposeDownload(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeList converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeList(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeDownload converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeDownload(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeDownload(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/", wrapper.GetComposeList)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/download", wrapper.GetComposeDownload)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXMaO7b4V1HxS1VuXtgXg111ax7GG7bxBrZjDymP6BYg0y11JDUY35fv/ist3XRD",
	"s8XJvXNn/MfMjWktR0c6R2fXHymLuh4liAie2vsj5UEGXSQQM38NkPyvjbjFsCcwJam91BUcIICJjV5S",
	"6RR6ga7noFjzMXR8lNpLFVLfv6dTWPb55iM2TaVTBLryi2qZTnFriFwou4ipJ3/ngmEyUN04fk2Y+8J3",
	"e4gB2gdYIJcDTACC1hCYAaPQBAOE0OTzS+FRbVfB8z34qIau37cPG8WGQwlqSPRxNRG0bSzBhM4Vox5i",
	"AktA+tDhKJ3yIj/9kWJooNazMFE6xYeQoacJFsMnaFnUNxtjVpba+2eqUCyVKzvV2m6+UEx9TacUJhLH",
	"Mj9AxuBUrZ2hbz5myJbDGBi+hs1o7xlZQvbT67v1HArtS4V6/sMLDAFPIT8zQVxkCqn0n7nsdIoT6PEh",
	"FU96t6MwudNM8HURqmSEJcO6Do1tAYWvqSSGKOjiOETQxZm8VSvlq7ularVS2a3Y5V4SxrZE8dxi5Lzp",
	"NWegXXrLEfD8noMtTcJ96DsibBcn6WYfcCSAoEB9Br+JIQKmC1DE+ykNIHAoGaQB7fV9bkGBbHB7c94l",
	"mAOGhM8IsrOgKThALx5mUA4NXDwYCtBDgFNKEANiCAnoUwaoGCIGfLW2LhGQDZDg2S7pkhksgvlITsuH",
	"lAnE5GwgMhmAxO4SHJ8QcyBh59BFAHI1lfw7Oh2YzTbboh6lDoLk7Zu62XYuO4o+c5JZcXQK2Shx/Fef",
	"obccl+HUQ+xp/DRABGl8xo5O6k4uP35yGkNKOVI4vmuBpivvpRM5zB2YjZIGNu73EUNEgD6CwmeIA0qA",
	"AhhA+b8xxA7sOahLbOQhYmMykC3kuAvD6Y1DxHclNhRQd8UIRmb0iSU8IcuZu8bkEaF9NYU+GMgGqoM8",
	"xcD1uTq4PsHffHnXqoYDPEYEMMSpzywEBoz6XladWTmJPH3UxUKSRp9RV3WRO4e4kAeZQWJTF1CCQA9y",
	"ZMsVQnB72zwAmHeJWSGyzQKjHFIBlsSCHGpFdiq6wHPzJVikx+gYy0UG4D8p8NNgMkRMb6GaRdKb79hq",
	"8QFeIJHdBpgLxBR8J3QiSdTBXADoOCAAg+91yVAIj+/lcja1eNbFFqOc9kXWom4OkYzPc5aDc1Dufc7w",
	"7n+MMZr8rn7KWA7OOFAgLv4ffA2Y+5Oc6Cmc5KNCuYQ4+EminlABuIcs3MfITgMs5I82sn0rtiFL8DCP",
	"dEnvyJf0kcz5o31Xn674cdkA3fOgdKhvQXJjhjlWMybd334vBOEJ24tANQ8kSNFmPwBMGVXsWq9oZWCv",
	"WM6Uy4VSZjdvVTI7hWIpv4Nq+V1UTIJOIAKJWAGXBEI32gwqcwT7mNhqrzWFap5yRZmAziZnMTiHAo9R",
	"xsYMWYKyaa7vExu6iAjo8IWvmSGdZATNyKkzGuQ5JFWsKupXejuZglXqZ8o2zGfgTrGYyffyO/liadeu",
	"2tW1V8kMY4t7u3AC11wIyy6cOIfchOXMARkZIAmEfcdHHsNEbHkVWZQIiIlRgubunOCbPh1cngLk9iT7",
	"JlJsGCJ5KKADIBN9aEmpMhRUPzDUT+2l/l9upnPljFaRC8dNEmAtnwvq4lcYXqyrhgqX3Yh3+z53fyZI",
	"zjbmgtHFVXekSCa/4Z6vSFdQ4HMUijiW1oKyoNkHDuoLgFxPTNWnIeWiS/TAYIIdR1ESX6TtPrIpg5nS",
	"bhIBq3PGk3RRaySJVH+XYPXkfckFdBxkb4p8M4pmbgn4d6ntG60yPn2dAOhgI+t5ehSellKi3Etb/dyD",
	"1mgCmc0VlqCAPexgMVWr3wa6JMAC2lnAVwDLUoy9FVdJ0IwR44nSQB1w5I4RA6YFIEqNj21/NVvNVvNr",
	"SX49sTcWiGUb0ocWYmI9tdYbsllsKk0/mkvjJMwfzD5K5FsMQREKdyHTwNtwjWDIadJ29G26rv/RwaVq",
	"iRNP95H8+WeBGu6PHDURXDnblAvkJoiTUtSjfTBrA1wpmnkUExEB8YeAMZMmgpTEcw6JVBbAUfOqDVxq",
	"o0RFro8ZmkDH2QIS0yHgdsuxMGN22616KX+TPDpZUWlQ0scDpTMFzFw1TNJ3BgQHF8sqKJpBO2WLU9xH",
	"0c+TjcbYWqMsRTsA3SENLJ9J9c6ZAkqcqbxc+r4T3k3IHqAMx67nKNk8E3A8BuQS5i6hnI3GOW7DxAUG",
	"HdeuMGz4PZ0aIUbQ2mNwplsZncpB69qf61bf0ynqIcIt6G180C49RNqN+pW+JphQm4HJ4Emd5ZjODX1B",
	"M87YXdC828hBlgBDKQVr0WBkpOXghg9HRnYWfAwG+qi/S9GBwQnwiYM47xKhRG6pi0v1lDLgUoZiFI6l",
	"toCtIbAgR1LiDsc5v2tlwUc1NnQmcMq7xOeIy9/TAEmNeTJEinGZKQgF6EUwGB0/Cz4yOPkIVE8JWQg+",
	"75KkQZbAGbcOMDhJpVMafyEqvyYqdB7leNm9cRP5Kol+wrBA8h85JKzc1Hezqn/WzsU5tLEnXFCBJIqh",
	"kN94gAShhDAABej52LGBwC7Kbi6UhMcphC7xDmJD7q4b6uak3Vq4SZm3vt/VYjeOmOQJa8FvB+1kHz4c",
	"oelydsv5EIzQlG+Kmnb75AwlYkPi+JWStdTdCdp9T6d8rhlOMmzy61vuv1uepHF8XyVfqfs7QcTTSoq6",
	"otfJDPqcxSUvGwqYrG5JyAP+r0aHHHgOlCOjF7FUW1gcTN1/8yNBMMC2pGVoTCTmfpvdCYwq5wAl6LKf",
	"2vvnorQd/oKJQAOJ0K9aaUhyniHmYi6FYA70AOFFpSDCBFBLQHV9uVDEAMnvlMtJy/WgGCYJ+mIIQpXU",
	"ia9JsQ53an5fGDH50F1OiPa9xfHnB/iTvX4S+uakfrXCr+tO5Ux6jB8tF5Nkb6L8NboeI1piAnpTgXh0",
	"GcVCuVqulXbKtXTqJTOgGQOKj4nYKWslMbgG4taM3BiytWpNpHM6hHfNgmcC5koFZ16m191sYBnRTvPO",
	"Be8NNWpQMt9Rn8FvUuulTAAGyQDxT8pU6zEqqEUdxZakdBJF4z9TxeKesLxUOlXLm39gF3rqn9s59Tbk",
	"9MGCoxxf8lZtgdqEWQYjPKpe2zHLUNhaOJSS33HBEHQTl/vMKXkSEDtU/bIGxGCa0/blRSfsJFkDdbA1",
	"TTR8XvlCUm9otAa6LWgeBExbXsxA8mueBlwyEigAJFMthBNLikqhWR4I2iXy3A6GgodSoJR6XCiwBR1n",
	"Kk8cQcoebtiSXImD5VDB5GZmixJOHSOPGE64l/J9ZXxc5H+MSuo1q1w8OdtiMYLBeT40m2klcUaEooWN",
	"70GOfObEz9+MXQRGY8smWYbsIdQGY0tfhDkbc5FjQ+TUcrXcS23naaeckyNSnqM8F8MWw4mm8Dk6Qkqb",
	"jWIupsU6aKmNaeANrCGyRsldB95ACU3RVa4FZskOukhAB5NRMqZczBhlPKsNiB6jcjuylA1yQb9/SAH5",
	"98DAWOz6+XxxBzJr+LvG4AZo05M4mItFIEIY5OeshYigXM3/D4YcBDn6vZbRpB6ZGcr/3ynrXxR8+5Cj",
	"y/YmsChz5NOQij5+SbY0cbmpHKiWkGExlfebQBF5Qzmzg1O6zB293L7IMJXDRj6Gt7fWZ55WHw/OnTFi",
	"uD9N+jxv5l9DbbdGWtnCzrfOED5I4phafsR2YP2WfBBBO5AgAr05nYCRZfbruvZi0j6YAR+x70Db1j5i",
	"KVkJGhXvZ0dQNS9sQutDmmTj6ZgJPnIgG4DQ1ZQ0ZKKmJDUkHe4hFaWY9Mf5MIPsYqVS2AX1er3eKF28",
	"wkbBeTxoFi46hxX5W/OCHZ8dstYD/txq3U78E3hTP3Vvzmnz9aZf/HZQtA8qr/n9zktu5yUJpkUPklxO",
	"IVlU5nxCWZIf0DiqTQPABWTqJhND8GHnQxp8qHxISzn3Q7H3IbRA9BDggsr7D/IugQQgYrGpJ++4YKQs",
	"uBRDxCY4YrjoISCUfmRrEXqmznRJ2C9Kk9FAKaSFvnmH+wAToD6a45ko1ycda0k+P3KqN7XMJxrLt4wl",
	"Qu5TaJiPCJOZTGb/8Lh5ARqHN53mUbNR7xxmMplul7SazUb+oNGo9/CgPmnu1wfN22Y2m+12SSaTObw4",
	"mOvyhkC6GXCJq49ECe5TW1HPTBdaJY4kRBkqxTL6yw3iHiUm/tBxNhj1UkF2g1RIjIWU/jXnlrXjxFQo",
	"llC5slPNoNpuL1Mo2qUMLFd2MuXizk6lUi7n8/n8ejFtE54erm7mMf7xRa1qH/NL62k1Ppv2fxAm9ZLO",
	"jcyy2aJU64SVBKSxoTNbzRzgdw396CFXr4EO+E/dGBU4oAyfiRKqASGu6kvGx/rQQn98T7pcR/QZrzXz",
	"02es1pIcyWAAWomKFiS4j7j4qfhwo4O+HRnzxo1w9NUrQwIGVsCftTAq5W70ZFHXxSIx+Oe3IeTDT8Ft",
	"J3dAANM8/QN+dS3PYWI5voojvDi8u6lv6VsPEbGBrSGCvxsd7Lf2aiVU6BDt2Q7NBZikU70wdObr9/nL",
	"uBcNq9nIyrx9DEtC6Eok/CTOVaU2nKmlloZgshleVnrtZOMAh/OdN+d988P8KJtYoKIYAiLb3t6/bP1c",
	"5hgsc1FNkHMBm1q+q4zyUpNU6Rfa96eJJzTh6JCg6NnfaMBZqKtxYB3OZvC5ryxJQyVtCyC1awHEhKqB",
	"eFr55YJBtF8LkTFmlMjxlXky0qJLoCV86ABjXAmdzGreTYlWbbicPtHj88aL72cIQklXHw/HXb+08BaP",
	"dkVbUsQyWUATxIbwSLqYDbRZnxgi71Qu0Pw+mIHiC9xkXw4ZoyzBtIsExMrAN2/SitlIIE80PiyKd2Hj",
	"BQD0eiQ3NC5n7lsW4nItfYgdn0kt0IS0ywVF9PKw4QLXnIUiLqxsRTT7QkRgECcZxj4vDSPXsaRJjm9z",
	"jGf24mDQIOoy7mlS1mg2zZqflOFUzbon4CDRQOLwp5kZatH1yKgDOudtoNrgPrYCZ0k4qcoTWWfAMgtM",
	"VA+DJb0ld2LFtoT7YcwNVjx+dS78hXLFNBNRBQcJLBwOtpxBR9cnKjXrcBPhhVsY+vDA3P3zJlL5e8Dx",
	"Awl1ISdjthiTEBKcsWTjjEmhmXO5XR9cJCd7zOHmmw+nWUxz7tRkHuTMfuytwNp8ck46WHLiaVNi1Qbe",
	"iX8T54QyID8NvEGyEVl/DqzNyW3e5N8w1s53B8Yvd2D8NN8D587TWz0Lf2UIcTz54GflDjytDjE7VAFx",
	"0TaxiPaIkxgTENfksqAzRBx1Sax3NNBfXtY28jh1xsgkcwmG0RiF42dBPcSvM02rgEA++zwztcOxyQfD",
	"rkdZxJP8r4VYuH/N/BhdYpj3jOluhtd5bpmA3rmI778kanvDKIZNwq43Hmp90PTKEZpX7W2ipIMQjAVq",
	"WeZX+7cKlY5mNr1HUP9tI6jjgdMzO2DEH+VRLgYM8e1Cmd6jsP8torA9OJXC+V9yVSqy2/i+7JKANC/b",
	"AAuOnL4qmzDVgxGqssfDvPY5ixijVADKugSSqSlOIBEdNYGrKD4Lcf5JwRxM/MSR4KCPkWMHYy4sB3OA",
	"B4SyIMFvI3b7HxBEHsmRXdsv2vYNYeGbX/6bh3kfXBxdOf4AE32dLSqIK/SpxPHMQd7UOTFXHYVZQyyQ",
	"JXw2F+ER6j0LZPxj7okfcS/MM4o3H/U57WS2kjn40nHEfI3heRYQMBdD8Ze7ruIR3QaaJP1rJiAvzzMI",
	"pfsfSTZAhPsMPXmQBYWvVteoOVTtQZBEA3RHEBH+AXrBUQtNNBJyg2yE2Wp0SkKYiWAyE7D9l6QkzMBa",
	"mZdQrVR+LC8hGmq2kJxgY/aDuQlz2AzzEkyaws9A5qYJCqGL4Gf5byyzh4u5+1Gvg+wBI7U4EnjXZu4H",
	"Sye4muZzAye7SNSS/4KoE43qtzjdpGK9ZTpF8+DSaFGAkh6FbF1ihY2f3P7gSaP7SQLx5ELrSbKqJfuK",
	"ffLk+b2nEZo+DSEfrm+FCUeWuTJXt5RnfxZZt2iog8SXPNRXwEq5CLGnpXWiFg6/UvO3Q2hbp+CEydWA",
	"I6EqziyVQtZxbh0JrQpzzY2dSm8kwvwNEt5+4X22xtP1nmz335NstybH7unvlmT3tDTLLtne+J5pt2Wm",
	"3fcVqG1HRv0hrAZgqVgAXZKDMmDr1JeEa5dHbozENO/IeLNRIvgUyCFIbIe72D21blbdOD5pX8iNI8Lb",
	"MkB9Kd4fg9zHLZC+j4kNYJiqQpCYUDYCOqxBJ6qAV0rUNciQhMoSQDDY72NLxX90iRhSjsIeYQVCdS0j",
	"ITAZhFeeHCnpwkw2u5OIbVv2TAO8UIMqmFZZx6DnOVOVrhgtNDqbdEl4ygoSDYYP7hZlo1ka9tb18/mS",
	"pfuof6N/5vRvLuQj/cvX/9O/tOoN/cP/YY8jsad/Vf/Wv693oiedhePG1VvCTXq+NUJiuZsBEi09yPu2",
	"3alfHNRvDkBbUAYHCFgO5BzsqyGy85UmzR8ZM8OWVTU7Q6TVvLlYpNBZKJmmKt5rgwZ1PV8gcEgGmAQh",
	"f13SCcv+qYHmCnFOsBga+e64cQWMpz5tjOKYK/Nt3DirwxZ17deZ41IVSouVjAwrdHbJRxM6yTLQwxm9",
	"5b6Pbb3jHwNJxkwnxQIRg3qbCp6zerOLqJRL1N8jNRHDNQUuhqgnNoJfSfUGn6qGb4hKKP/Gtho9KKCZ",
	"BW2EQBhc4lDfzg4oHZgQLq6PjqqjmAvrcJrSp/G6myqYx3cEzhjIwxqdlkM54iIQ0gz9kd9MeczgeOqD",
	"GXb7JNFsSd5F4snM80hG/hZVrZPZiMGLWjcImkt41Sjxk5x0fNXxzHaJipc1h0Rh3YQURJK9Q8HSTKMc",
	"eVlwpyDQwjAHkKG9LgEgAz5KYXPvD+RC7GD7+8c9UCdA/QWgbTPEuVYlGPIY4kp9Ceey5BBgbllZcEQZ",
	"MNhLg4/QwRb630jY3sesmdncj3Xdb0sY9NRmiGVzu9OMcoJkoOf9L/Q87lGRHZhOQZ8oSEpz2RYbZv1B",
	"tVcJ1xwKbBcTnogDm7oQk70/9H/lhIo8QdvHAgH9K/jNY9iFbPppcXLH0RMGmaTmpoXC9J3HyIz0PkqR",
	"6uMcTMlUt/poBhVyNXNQSZWQTLskwG93TnZVB27hVKRCYTQ4D5tuXsroqXuLaE6lUwbB0R9/SV398N79",
	"eRVR1d0sx3+aTzaD3ELEhkRkegxiO1PKlyqF0lolKTJcel2B1eNA9d9CeFidWW3YkjYOzIwqv1FPD/8p",
	"Mbt6fZHtuQF/vMxkMxKjsYUEHXRbowuqmGZb6wubRIAcBu11LA0XPUrFpp2Pwg6JQuLCHFsX0TX+w3UG",
	"ZtVuFa6PoivbAoTEaNwrRseY62ALcHtzvlFQbSJ00USfX+/W1KSof94g36Iz9bRjWmfArY1taXdkq1/h",
	"1Iw+5WJskvkFq6+xEalFpkPbUBbcDxEJnmTIR4tyyw5YXqwuJtj13S6xUV/V3O1NI+2UXBO/XMrF3fLu",
	"TrW4u7PMyKTF9SfqbZSqFtekZt3NSw/JsrWcU6cj6X5KV1GCq+eg+bciTAaUQC7Qi+RdAgFHHmSSOZrW",
	"NpIalxZ21QWLBQd0QoIpsqBlxu+S2ZMIZg6pRUyQ1I75DIzgm+Gh6l2LkTIFMNQl3Pf0jb9FnIfGVUeN",
	"u/YijVFJjADmTunXgBpVFtai4xt7yMFkrdZolmli7kHQzWh3Q6NnhYE+epSeVPiMTqiS2cKCytnEyzqA",
	"xfNZ8G7QIjjmY/h4gumkY3H+pcBjlIp/RWCERhvsU6YNG4vZb7aPJM+bEYdqYgZVv8wGVEE9gQCpFYXl",
	"mXLgwA9TdIh6YQPQfpdw6kbJkKdN5JYLVahTeMyCOWMHrUsMErKRUK5w5cFxSIzj4j3qbpBtGHhqPsr2",
	"6lx9NKpPZOc2yX0O+68gdbOyGABZ0IiHXbavDr5IpjajrMjauWe/JCx3PtOop6XkEKT03PFPOIIz8lki",
	"laLAh71xnl3oit06z9Bk6IVcdLMB4vUc5jpvcY/Nj7OSPwV5gnH0bZWSl9ZHWv9TA63/HRRWM3l7C2c8",
	"csdHpoITOQ2c8MwQZtjQx+avyD859MI/XzUw+ukTBL1q7Ev8j0g/FQ4cpsibv4IMBPPDLNI3nRoo38PA",
	"CgcYSJEpVGjUf2MdMBUZKe7BnhMfWn4IJ9Z/xD/Oj8LgZDYPFYlBzKl0ysHjOARKqIBORseOUktCPeae",
	"ZF+zf2XoGKbSqQl3lmyRJOIzUwMtTlGLofs/YMVtRqOp4+Nz36YZQlUpIXu7DCafQCEQsTcP8TsL47O3",
	"EYE9SQMJbnX1OweQDUxOuLlY5IFQuXMM6IBwVaVBilCSmcVscYRyV/zep8xCq8pFLdcWzQRhHaXZ0PpL",
	"xkY9f7BZEuOZyff/gXTO2bRHOvOr4VDfzuxDvsSWq3K14j2L+WI+v5uvZvOJ9kkV0ZGclTaizzghJU3+",
	"PPR7myTzQT6at0qUi0n6e+ThiBkcpfXvnRnwZ1OZzZ2NOMPK1yV7E5SWmTfESOI1GdxElQ5ZCCQimg3p",
	"lsuGX3anKr6/CXaSzlQQXBUfUormSx4DGaAlyXJGM1v8IqiATtKnOSyoSdPhg576HU3dOb001iqt3gdz",
	"tvNBrRpj6euKJv7mKYjaWPMoYqz5UrjRlsYf3WmN6WeEpip8bJEztZGRwYMmwIFT6sfDVfzEVH4HkoGf",
	"HPQbeB10tszCczBpE6/BZCuCQA9Z1EUcGCtzWr3khb75ShmQsjtkCHBkUWJDkx0dMeci8nTbzt52jjK1",
	"t/qxLxvNN56bcIRf8hCisaTs/ZHwqBQiItEmVVfPSyo9U7mvORLp0L/Xpwz0kbCGUnkzo2RBUwoyyHga",
	"/uUz519Kc0Ai0OTTXaIV11gqpjIzmBhtpXQs8XnrgLCE8DRI5FgIq7QRaColgd/MXu+BfHEnX+4VbbiD",
	"divlnl0q92q9WhHWShVUgdWqXezt5Pt9+Cmtw5h6DBJrmHHwCAEW1nuYjceGyJklk0vZ8tOc522xRfLl",
	"2F8M69+gm0k9WR1Od4AEYq5SYSdDZFCj3XmxB+9cSOAAMfCbBYntIA+TTwDbiAgspvp1UX2+VHQCVGrD",
	"QqVW0KCE+y5iwJKHS9WkmE+4hRxYDpakGW8zRKRLwrMUngMpRAUHa0kh2M1jPucjmBcIYWi2YtHCmXx7",
	"LbnWksqkmMtIzZBIm0urcb+X2/4blttO3oZEZWvJ/b9mMcvBSc9GXQXZCqi4St5EW2tnP9IviU6Dd9x+",
	"WqWZwFhpkokEDYSJLDjCDgIDh/Z6JnAltHCluwQNsuCjysHlw8z/fJzj7sL1E2v+Ln1r7tJ4CsO35lbA",
	"FbxW2HMgGemKYLrSSiR3Mhgm9nQhuMeObalH/ZTcEyzHrKacLRSyC0spZUvwxx2PZr8OwiyPBJ9S4lFQ",
	"mobA7rKskdWFsJFHl4zrYAuZRLOlKvYqHTXhCVlXipaJ35Lvn9gx2ACvSXqhzqVbhfIf8XIn00nstcrF",
	"4G1IoJKfM4JSh7/5qETraW54VlRBHe67K8gqoKOgKfC5JOr6+fHl3km9faJs6PES4ENYrOzsVYqVaq1m",
	"o5Jtl8vl3apVrNrlQrVY2amVdnZ6xXyploc7vZ1qvtrPw8JuNV+ullDZlv/YgeV+Yt7D0tP5YycQD1y7",
	"suyTdm2sYLdvOZ/GWL/2mMrt9R1PaxlvCuKEHCXnMuybL0pZmOWdGtfRTBRdmRI7XfGOmUrZ1HYT43ET",
	"DKFAl1Bl7pdYqp5MgJW61lean+ZTaYPVJtLLHEKX6YWq0NRGymHYMmk6laq+JLvaJv0nT+Vf8w2yyFuQ",
	"hPna3Aw5/xa30Tk2Gy0Y4/sysOfzIZbFfKxN1V810dW6efTZeQreF1ntWgqt8MmTbXZgY7abbJfUg9qj",
	"qgSFljA+mtppH9Pg46yclvrLlPH6CGbrUKGZXdJDM5VACSSqmIUe0dXCRTzOjjJbh296DFnIVuoy1tU7",
	"tIcechWoL9XAHh0nRtJHirz9ebXdtq7ltlli38AbmPKMJtA3fPg+3LxA0V2i287qvM0FpV0dgxGahjU5",
	"5BUwc/8r1SmumsduvUwmfJzg6vgKXN3unzcb4OzwAeyfXzbO1Ocu6RL3unmxf1y32hbdP6wfnPdrDycj",
	"9Hq6A22n9TCpwuPjpnMKHVE7fS6+5PaLZ5+HzX7TfzkW3t1zFXXJ+c3g4La68ww7Fe/uoOIetU5L3ggR",
	"dJOzOu63b9eji+k1H34p0usvk8PX23av0LhoNfqN48HoS+262CWvjyPWtBrsKH9dnLCzngN9e3j7Gd9B",
	"Uj/gbqH2cPiN9yr121LVFresVbp+sO8Huzefv+Cr/l3tpkvO9p87+dL4bv/SbrX5Q2n3HDbITtMrXI69",
	"WvOQ5pro8O6h8M1tXF7V4Vm+d3pS8vuDcsNHI/650+6SyfV9BzXOX/zH853L1hd6eXU2Gbeu+y+9QeHL",
	"QW3sP+bPxHPOujgpvkA//+Lyur97cuqh0fjy6ubF6ZLpN/E8fewzeofR0dSbPA7G1xNBSKuWG7QP/dzp",
	"XYc95CtF9/C2U21YvWp5ZJ0cdY76rZFDRse5Lsn3b8v1G1jJl09KL8/5keih0vjMuvpCry79s/07ftIe",
	"5/O3xw/16RXyp59rVes293A4bFVHpfbd2XOX7KDm42CKW5f5iVN4OD64ObN8ZzLiu/XPvjMaFGinV+al",
	"V/dxfJWvHtPOy325+AzPKvftzxfDR4S6pLaT/0Lvhj2rcOa1Pz/3H+kzZ4fisXbVu338/DA+qt14zL6v",
	"s+eT3umoeOrdnNVfOsMXfl3n+8PjQpfkz/2X4j1s7ecHxWblymrZpznr2zPN1yyLPe9/8fHLPcMV7O+2",
	"vni1b51cv/164XK7OSC13LfHsy7BtWvf6fvVqv9teJ+biGJPECwGN/zb8/Cl5T8/3JYfe+XhSBzVhme3",
	"uS9fquXit+F55WxSv6lf1/e7RBwcHT/e34wt93BwdtAqnLXrtUf3btQrnQ7PO63C+Zf9KbwvDC3i1IPf",
	"rZPTMXTvnu1GZdwllmt9xtenl/v7rf1GvV4+woeH6GTHZcOjk6p/x6/PW61i/qFiPQ7Jy0PtqO4qGmoc",
	"T2pHjcmo2SX7k+bx0TU9bdR5Y3//oVGfHDZOBoeNo3K93hiMrme9P1881HPV/Qdv4Ezb9ceHk+Hz9GzY",
	"JbnP/Z3Xq/7duHdSzB9+K42a1cuj/Ys8Of/yef+24Prj9udvHb9duj9n+yW3dOw7wju7OTw9Oxdu5fCg",
	"Swrs+PVLnXYKU2/3oVk7rx/YrUbjcvpcf+b0/rZWfbj1G59zPfLMOuimeH5z2ehPrxrVnfvdWgVf3nWJ",
	"W2l/7vHrg0m1UTxnjl1vlVsHPp0+FtpYHMPH8tn1+Z343DmEhTLmD+3jxvMrrV491O5Kp5ejSr5LBt/u",
	"B7XiRa7nFg9f29VOrXR/eNArOOPnctMZvwya387QoFB4/fLw4rKH9uPpaaM/fu1/di7aO/7L4KRLnl9y",
	"p/mp81g8x71jtnNcr08vd2/vWf2xPWm38ofWc6c2OWyQl1H7wJ9+c+8nd+OL/S/+YfOudolKD13SwreF",
	"/ulFjdvVA48fvVRan7/YpEWu259P2HPn6uyg5N4zp26Tw87QfrirPT+OvPvhwZSXcru76LJLhqM8OyfT",
	"/PPFZAT9fg7f1i6tnS/j1uj5/KZ1Oqjc7t6dTU/9+3vxOvlCnlsXlfubo/1vZ2X+SN1Wq0v6otc5KXyu",
	"THs397l6abzfgy8390VRvX29eLZe0aj9eIjh+cXuee7EOm00bwrXR7WdWvHArjuHR7t2l4yKg2v80L6u",
	"Q3iaPz2tv56Mb0Y3p+fng7Piw/UDPrm4mxZF6XR61OcMupVJu3F/2R9eoeb0fL/zeNolY+ZdOFc91Oed",
	"3Uq10y/uXzT9wesja1TuXg7aZ6PHwc2wcHc8bjevSWP6Orqe7hzeFr9defi+sit51PCq+eWRnVHrrHR2",
	"3t7N4dfT686NI55b9d+75PerfqeqnrjRj9ysuHqWVKCjDD1x7iRf0u91TNc/xLbSUfCzHmaLFuRKtMfJ",
	"8QJVXVftUu6WiFQEuRRoOFAqVyRfRxUD65LfgjixT4mFwRYyNoLC0XTL4nc/18MSd6KAJT6UDQs/mIec",
	"t9OrE0XJum2HLtzAGm+eXIO+GFKGX5Gt9JnF6gEbvaBWb99jMbo8Kd/WquVDm+/fkqnolXqT8c1gcOJc",
	"O72HL06VFPLj3SWVqxOLENzqd+dC9UdnoZkHseWRituvbBeT9fH0XIVsSDwlacdtJOnRmLD4nxdf/yMF",
	"wJaX1KrL4620NEODBLrayc7V+iTusqCt7cYc/A+YhAZlFcGrmqdBzxcqb0oSr7EJ8blw6/UE9ourlIVI",
	"WF+kbH5vty9Vps3f6nU9jVdMNJOWxK9eGji4ONqyZllgUn9TybKNyxn8hLIEoDeNPMuXUKY9KKtrJ1+g",
	"pKm7FH5KvYK10JC+iuTkWwPjQj7aFBbZdi0kuoLDtlhJvBqi5rJFQ+EGBSv1CFFbmL4LLcSEvUVn2XyV",
	"NW2JmXCR5hi1/TCNcGX56rkSkT9ocVwYZjn08wtddGj4gj6ZpxngnC9r9RU/vwt7CU+j6XegPMq3GDXm",
	"VZsD1hJ4rGuoGWEhlujJkcWQyOiHVEMJNHy4NKniJeToKdGet2jO20CqDcIKYsMtq/5E2QCSiKE2Gnla",
	"zpeK5eSoGmu9yBd6nPoOHAQlHdjQ0kVGdCBEpKxXUIUBOpyaGsSGQXHQNCuaE1qXrSle5yz6Zs5sW7OS",
	"ViOIXYvXucskhrf0/JmIwRDZ4MjmJF1CnUgh2S3iE4NuayIUifA0VCuiCYnwQNAoph7ks4QyMcxAFzFs",
	"waxHqZMlwpPqWSqdKqz6vJU+ES2muzxKIWiVDi4MdYncdhoxgfa2nTuE8pyRzWK9F/1xZLrxQ6/zeYRr",
	"+7RL23VZqPqydo5Xn6Htuix5zmhdt4Rw4HVdFuJA13VY5jb9/jWZ8wQqs36LbjHJUlU3wRzwIfUdGzCk",
	"gq56qir5ZV+J7oubpHNWVeysUElyCXufBWpcF0Fi4juh44CEhkCfPN4lkCHN+LRKvDAvDNsaLjnGVEW6",
	"aJeSBLhLmO8gXaOcoT5lKA0mCAzhOKyno04zUDl8cnU9BOAEBmUEsQCYk4+iSzzKOe7pooguflHhhS4U",
	"1lD7tsx+AEEHSpGXTDmknWWu10gu7jaPJ8/lc21MUhv2mK/nsAVBbdgj+QmsjWljw/ZLHOBbUG30KeXt",
	"U/bCpL9N0ttNDrHOb1/2kp8JpwiOzde5A7Zlkh7zCVmWiRdLaV44t1sv6I3Z58lRJXNDfl16dS3PKMzy",
	"UpjKFyQORrPvqIWzhsXoSkoSgb7jZU39AfMsRzIKje1pmyoi4bsvCWqe+ljY5H2xBfl7I2PbBTs+O2St",
	"B/y51bqd+Cfwpn7q3pzT5utNv/jtoGgfVF7z+52X3M7LqvyzaPIGYoVkA5OR+hdfLg6iGnUDwAVkKhJY",
	"DMGHnQ9p8KHyQYXYfyj2PoRPdfQQkNujQsS7BBKAiMWmnlAGFT1SFlxKrjzBkRc+eggI87qfKkI6K0bb",
	"JWG/ePDwcn1lsyg2JYZbPsNi2pZHXW/7PoJMn5We+tdRMN3pfUcKzaqlFOZ1u3BUqQulvn9Xyk2fJqXY",
	"6BJRghortyrVpsNEdQo7z6ZiIY96E1N1D1pDBIoqvU4pDKE3ZDKZZKH6rFwQpi/PnTcbhxftw0wxm88O",
	"hetooVWog3DZ3lfTm2RqBlQtNAA9HAkK20sVg2dr5Ie9VCmbzxZSujStQlPOcihBPPcHtr8rakmq1neM",
	"dPSV5pmqbh8wjE6eGxUsjkTwVKE2rsHwWV8j/OjXAiJWecqUwXJWZEAV3MGUAMVika2z2sMy4k1bgxJ9",
	"9l+ln0AXCaVq/DPh0e6gVEgAvKBgoOoFYqLOnhgGsXR7wQOqwYnTSp9mn7/kdf6vcjZt2VSbUcznI/k/",
	"JvfVMdEquWdThX0G0EpxIIIldZzjmIniRB6R8k+c2qT0L07aJFroNCcDYFtPXfj1U9d9VXV5hJTjB2tA",
	"9OylXz/7LZn5buQJ9BCTZwOEZ1tDUv4zIBkROiFzW1D5M3b/lqAXT2eZqDIRgFrqMTE7xsIVFQfM+59f",
	"JY2E0d6qSEaUCSnmFZ4nNU4u+EPVS056z7WhC4VBQNAk6JoGHpVLx0E6DDdFSZXteIwYDJi74vdGxVMP",
	"mmsfHWZRhY8vMq4ryoXh1YbJIC72qT39eRQff9v/e/z6lMzs+wK/Kfzs2Zt20tabj6oyjhI/kP2XMR02",
	"e3D/nfO8c54NOY9hGkmchufWCk5BOeyghzKdTIPyRqH8lA4ffU53iVKCnKl+yVTJ533lz0yWifTA5/oh",
	"hl8nVESmScDz/DLfaeydxra83RePUIzSfo6asoVmEmByjUoSrWi1mVISDvxfppbEMJVwjuJ4eVdN3pnX",
	"31Q1SZQUJP/SJpeofpKgKcgmM3VhA34SYVb/RlzkF2g5Ecyogf9sPScyfxiWlnCkVK1QNJkVNe+pkpq6",
	"qPQS7UegF5FTFtM4PPOo3Zh7lX/WBEm0+T0mH0u0xJ7zWEEANp0QKecuvckPTAN1qsOn0TRh9THBfBi5",
	"xVdcyME4213JggJ71vFvdyFTSyBhgtfj2xzO08MEJmXlJh/jsPpL8FqJ9nOH+H+/o9/v6L/FHR1jKyFX",
	"0bEbs9O8yK8cU/jvR7SOBXYFVuocWMxUjbSyNapgDUmCsQBm2KO+MNmr3HfESquABP9dKVlv1pB4WsID",
	"5RFI5n+qBj2hKhcGW74DmakNDX4TQ+oPhibS5rR9efEp+x938R+rJ5AGfAMyciHBfcTFeloKW25ATjdI",
	"+IxwlV4f9FPAKOu8Eb+IIRUlj5oq+WFjiyrCCuvHmu0LXgmAAkQdtabou05WgyRn/s4Ew2UrK0ixFaLg",
	"nR7X0uMMWcsEk+h2byqY/M1pLU4eGxBdpLTPapoLaz0mStn6gTb0Im/M6EXEFPkhG9hIl2OmMVoLgwLU",
	"8xqrKCOA850w1hNGgKt3gf1dYP9PFtgXeNN6fsd71F0uYATCAgQ6qjr+zAZfIzd0yVxzyMI26kWO2aMg",
	"S10E+5etLS9/CZMOxdZsDgRj/Je4CtRql3A69fG/7fqfLXqeFGzkceqMUa7n+Mhj5u3z5WbmA9N+P2z+",
	"a4y2wTxbxabkf8H0y+21QZtZvrAqHPFnX5XBDr6HqSxemH8bM1Owh6riG9O5LCFFGpe2Gjx6US3cGApE",
	"E9Exd10krWzWJKeeWFiWkhFpp95g+KU8fLaGpCMXevsNMt7P+l8jHOqD/vcTDWF4gKDjgDCZLDhNMzJb",
	"HzcCSVg8PfCmashmVdh7U6BkoGRC3dxLi0zzN4lvpT9ZGFu6leoDiP72TsXvVLwNFaPFEyQpN0xaWX5D",
	"Xpombzz38/lECws1oCheIPU9OYTR9f6O2vTK5UjU68JDuWhtneU6RLxSzy9SIJJLPf3JasSSmkQJm6Vb",
	"ggASnWsX6BX2rIjQn6pa8ACod8Xib6pYtMOCYOYQITtmi6ckIhLFyolpgMKaHAvSSQtiAn4zhX0wJZ9A",
	"+GBePFURejirXuAY4r4uEwM9nNMPcyo/GGIZY5NguXFRaSFztCHgAJPBqgm4gAP0xmks/WAusKkLVak5",
	"Pc26cb5+//8BAAD//5iy8+jo4gAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
